package com.intsig.idcardscancaller;

import java.io.File;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.Toast;

import com.intsig.idcardscan.sdk.CommonUtil;
import com.intsig.idcardscan.sdk.IDCardScanSDK;
import com.intsig.idcardscan.sdk.ISCardScanActivity;
import com.intsig.idcardscan.sdk.ResultData;

/**
 * 
 * @author fei_cen 注意：初始化过程中如果报错，报错日志会自动存储在
 *         /sdcard/IntsigLog/IntsigLog.txt文件中，请前往拷贝发送给合合信息技术支持分析解决问题，谢谢
 */
public class MainActivity extends Activity implements OnClickListener {
	private static final String TAG = "MainActivity";
	private static final String APP_KEY = "75412a2b2fc7dfb1aacf2e7c11-vagfvt";// 替换您申请的合合信息授权提供的APP_KEY;
	// 58959e29b5acfde38059004551-Vagfvt

	public static boolean boolCheckAppKey = true;
	private static final int REQ_CODE_CAPTURE = 100;

	public static final String DIR_IMG_RESULT = Environment
			.getExternalStorageDirectory() + "/idcardscan/";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);

		if (!boolCheckAppKey) {
			useCamare();
		} else {
			setContentView(R.layout.main_activity);
			findViewById(R.id.btn_use_camare_module).setOnClickListener(this);
			findViewById(R.id.btn_not_use_camare_module).setOnClickListener(
					this);
		}
	}

	public void useCamare() {
		// 通过Intent调用SDK中的相机拍摄模块ISCardScanActivity进行识别
		// ISCardScanActivity.setListener(new OnIdCardTimeOutListener() {
		//
		// @Override
		// public void idcardTimeOutCallback() {
		// // TODO Auto-generated method stub
		// runOnUiThread(new Runnable() {
		//
		// @Override
		// public void run() {
		// // TODO Auto-generated method stub
		// Log.d(TAG, "预览超时");
		//
		// Toast.makeText(MainActivity.this,"预览超时",Toast.LENGTH_LONG).show();
		//
		// }
		// });
		// }
		// });
		Intent intent = new Intent(this, ISCardScanActivity.class);
		// 指定要临时保存的身份证图片路径
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_ORIENTATION,
				ISCardScanActivity.ORIENTATION_HORIZONTAL);// true打开闪光灯和关闭按钮
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_TIPS_FONT_SIZE, 18);

		intent.putExtra(ISCardScanActivity.EXTRA_KEY_TIPS_FONT_COLOR,
				Color.WHITE);
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_SHOW_CLOSE, true);// true打开闪光灯和关闭按钮
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_IMAGE_FOLDER,
				DIR_IMG_RESULT);
		// 指定SDK相机模块ISCardScanActivity四边框角线条,检测到身份证图片后的颜色
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_COLOR_MATCH, 0xff2A7DF3);
		// 指定SDK相机模块ISCardScanActivity四边框角线条颜色，正常显示颜色
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_COLOR_NORMAL, 0xff01d2ff);
		// 合合信息授权提供的APP_KEY
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_APP_KEY, APP_KEY);
		// 指定SDK相机模块ISCardScanActivity提示字符串
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_TIPS, "请将身份证放在框内识别");
		// IDCardScanSDK.OPEN_COMOLETE_CHECK
		// 表示完整性判断，IDCardScanSDK.CLOSE_COMOLETE_CHECK或其它值表示关闭完整判断
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_COMPLETECARD_IMAGE,
				IDCardScanSDK.OPEN_COMOLETE_CHECK);

		startActivityForResult(intent, REQ_CODE_CAPTURE);

	}

	@Override
	public void onClick(View view) {
		int id = view.getId();
		CommonUtil.deleteAll(new File(DIR_IMG_RESULT));// 清空之前的目录

		if (id == R.id.btn_use_camare_module) {
			useCamare();
		} else {
			// 在PreviewActivity中自定义相机拍摄模块，然后直接调用SDK中的身份证预览方法进行识别
			// 在PreviewActivity中可以直接获得SDK返回的ResultData识别结果
			Intent intent = new Intent(this, PreviewActivity.class);
			// 合合信息授权提供的APP_KEY
			intent.putExtra(PreviewActivity.EXTRA_KEY_APP_KEY, APP_KEY);
			// IDCardScanSDK.OPEN_COMOLETE_CHECK
			// 表示完整性判断，IDCardScanSDK.CLOSE_COMOLETE_CHECK或其它值表示关闭完整判断
			intent.putExtra(ISCardScanActivity.EXTRA_KEY_COMPLETECARD_IMAGE,
					IDCardScanSDK.CLOSE_COMOLETE_CHECK);
			startActivityForResult(intent, REQ_CODE_CAPTURE);
		}
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data);
		if (resultCode == RESULT_OK && requestCode == REQ_CODE_CAPTURE) {
			// 获取身份证图片绝对路径
			String imagePath = data
					.getStringExtra(ISCardScanActivity.EXTRA_KEY_RESULT_IMAGE);
			// 获取身份证头像图片路径

			BitmapFactory.Options options = new BitmapFactory.Options();
			options.inPreferredConfig = Bitmap.Config.ARGB_8888;

			String avatarPath = data
					.getStringExtra(ISCardScanActivity.EXTRA_KEY_RESULT_AVATAR);

			String regtime = data
					.getStringExtra(ISCardScanActivity.EXTRA_KEY_RESULT_IS_REGANDDECT_TIME);

			// 获取身份证识别ResultData识别结果
			ResultData result = (ResultData) data
					.getSerializableExtra(ISCardScanActivity.EXTRA_KEY_RESULT_DATA);
			
			Log.d("result:", result.getOriImagePath()+",trim:"+result.getTrimImagePath());
			// 在RecogResultActivity中显示身份证识别结果
			Intent intent = new Intent(this, RecogResultActivity.class);
			intent.putExtra(ISCardScanActivity.EXTRA_KEY_RESULT_IMAGE,
					imagePath);
			intent.putExtra(ISCardScanActivity.EXTRA_KEY_RESULT_DATA, result);
			intent.putExtra(
					ISCardScanActivity.EXTRA_KEY_RESULT_IS_REGANDDECT_TIME,
					regtime);

			intent.putExtra(ISCardScanActivity.EXTRA_KEY_RESULT_AVATAR,
					avatarPath);
			startActivity(intent);

			this.overridePendingTransition(R.anim.cui_fade_in, 0);

			if (!boolCheckAppKey) {
				finish();
			}
		} else if (resultCode == RESULT_CANCELED
				&& requestCode == REQ_CODE_CAPTURE) {
			// 识别失败或取消
			Log.d(TAG, "识别失败或取消");
			if (data != null) {

				// 101 包名错误 102 appKey错误 103 超过时间限制 104 达到设备上限 201 签名错误 202
				// 其他错误203 服务器错误 204 网络错误 205 包名/签名错误

				int error_code = data.getIntExtra(
						ISCardScanActivity.EXTRA_KEY_RESULT_ERROR_CODE, 0);

				// 注意：CommonUtil.getPkgSigKeyLog返回的是报错的详细日志，请将返回字符给合合信息技术支持，可以更快定位问题

				Toast.makeText(
						this,
						"Error:"
								+ error_code
								+ "\nMsg:"
								+ CommonUtil.getPkgSigKeyLog(MainActivity.this,
										APP_KEY), Toast.LENGTH_LONG).show();

				Toast.makeText(
						this,
						"初始化过程中如果报错，报错日志会自动存储在/sdcard/IntsigLog/IntsigLog.txt文件中，请前往拷贝发送给合合信息技术支持分析解决问题，谢谢",
						Toast.LENGTH_LONG).show();
			}
			if (!boolCheckAppKey) {
				finish();
			}
		}
	}
}
