/**
 * Project Name:IDCardScanCaller
 * File Name:RecogActivity.java
 * Package Name:com.intsig.idcardscancaller
 * Date:2016年3月15日下午3:58:29
 * Copyright (c) 2016, 上海合合信息 All Rights Reserved.
 *
 */

package com.intsig.idcardscancaller;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.os.Bundle;
import android.support.v4.view.ViewPager;
import android.support.v4.view.ViewPager.OnPageChangeListener;
import android.text.TextUtils;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.ImageView.ScaleType;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RadioGroup.OnCheckedChangeListener;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.intsig.commonui.MyZoomImageView;
import com.intsig.commonui.ViewPagerAdapter;
import com.intsig.idcardscan.sdk.ISCardScanActivity;
import com.intsig.idcardscan.sdk.ResultData;

public class RecogResultActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);

		setContentView(R.layout.ac_recog);
		Intent intent = getIntent();
		String image_path = intent
				.getStringExtra(ISCardScanActivity.EXTRA_KEY_RESULT_IMAGE);


		TextView use_time_id = ((TextView) findViewById(R.id.use_time_id));



		ResultData result = (ResultData) intent
				.getSerializableExtra(ISCardScanActivity.EXTRA_KEY_RESULT_DATA);
		String regtimeall = result.getRegtime();

		// 图片角度,如果有图片的话
		initPagerView(image_path, result.getTrimImagePath());
		Log.e("RecogResultActivity", "image angel >>> " + result.getAngel());

		View front = findViewById(R.id.layout_front);
		View back = findViewById(R.id.layout_back);
		if (result.isFront()) {// 判断身份证正面
			use_time_id.setText(regtimeall + "ms");
			front.setVisibility(View.VISIBLE);
			back.setVisibility(View.GONE);
			// 获取身份证姓名
			((TextView) findViewById(R.id.tv_label_name)).setText(result
					.getName());
			// 获取身份证性别
			((TextView) findViewById(R.id.tv_label_sex)).setText(result
					.getSex());
			// 获取身份证民族
			((TextView) findViewById(R.id.tv_label_national)).setText(result
					.getNational());
			// 获取身份证出生
			((TextView) findViewById(R.id.tv_label_birthday)).setText(result
					.getBirthday());
			// 获取身份证地址
			((TextView) findViewById(R.id.tv_label_address)).setText(result
					.getAddress());
			// 获取身份证号码
			tv_label_id = ((TextView) findViewById(R.id.tv_label_id));

			tv_label_id.setText(result.getId());
			// 获取完整性
			((TextView) findViewById(R.id.tv_label_complete))
					.setText(getComoleteTips(result.isComplete()));
			// 获取是否彩色图片
			final TextView tv_label_color_image = ((TextView) findViewById(R.id.tv_label_color_image));
			tv_label_color_image
					.setText(result.isColorImage() ? R.string.color_image_yes
							: R.string.color_image_no);
			final ImageView tv_label_img_id = (ImageView) findViewById(R.id.tv_label_img_id);
			shotPathString = result.getIdShotsPath();
			tv_label_img_id.setOnClickListener(onClickListenerTrim);

			// 获取身份证头像绝对路径
			String avatar_path = intent
					.getStringExtra(ISCardScanActivity.EXTRA_KEY_RESULT_AVATAR);
			ImageView avatar = (ImageView) findViewById(R.id.img_avatar);
			if (!TextUtils.isEmpty(avatar_path)) {
				Bitmap bmp = loadBitmap(avatar_path);
				if (bmp != null) {
					avatar.setImageBitmap(bmp);
					avatar.setVisibility(View.VISIBLE);
				} else {
					avatar.setVisibility(View.GONE);
				}
			} else {
				avatar.setVisibility(View.GONE);
			}
		} else {// 判断身份证正面

			TextView use_time_id_back = ((TextView) findViewById(R.id.use_time_id_back));

			// TextView use_time_all_id = ((TextView)
			// findViewById(R.id.use_time_all_id));
			// use_time_all_id.setText(regtimeall);

			use_time_id_back.setText(regtimeall + "ms");

			front.setVisibility(View.GONE);
			back.setVisibility(View.VISIBLE);
			// 获取身份证签发机关
			((TextView) findViewById(R.id.tv_label_issueauthority))
					.setText(result.getIssueauthority());
			// 获取身份证有效期
			((TextView) findViewById(R.id.tv_label_validity)).setText(result
					.getValidity());
			// 获取完整性
			((TextView) findViewById(R.id.tv_label_complete_back))
					.setText(getComoleteTips(result.isComplete()));
			// 获取是否彩色图片
			((TextView) findViewById(R.id.tv_label_color_image_back))
					.setText(result.isColorImage() ? R.string.color_image_yes
							: R.string.color_image_no);
		}
	}

	public void onClick(View view) {
		if (!MainActivity.boolCheckAppKey) { 

			Intent intent = new Intent(this, MainActivity.class);

			startActivity(intent);
			finish();
		} else {
			finish();
		}

	}

	public static Bitmap loadBitmap(String pathName) {
		Bitmap b = null;
		try {
			BitmapFactory.Options opts = new BitmapFactory.Options();
			opts.inPreferredConfig = Bitmap.Config.RGB_565;
			b = BitmapFactory.decodeFile(pathName, opts);
		} catch (Exception e) {
			e.printStackTrace();
			b = null;
		} catch (OutOfMemoryError e) {
			e.printStackTrace();
			b = null;
		}
		return b;
	}

	private String getComoleteTips(int completeType) {
		if (completeType == ResultData.NO_SUPPORT_FEATURE) {// 不支持图像完整性判断
			return getString(R.string.no_support_feature);
		} else if (completeType == ResultData.IMAGE_QUALITY_OK) {// 图像质量完好
			return getString(R.string.image_quality_ok);
		} else if (completeType == ResultData.IMAGE_SHIELD) {// 图像有遮挡
			return getString(R.string.image_shield);
		} else if (completeType == ResultData.IMAGE_AVATAR_REFLECTIVE) {// 身份正面人物头像有反光
			return getString(R.string.avatar_reflective);
		} else if (completeType == ResultData.IMAGE_EMBLEM_SHIELD) {// 身份证反面国徽有遮挡
			return getString(R.string.image_emblem_shield);
		} else if (completeType == ResultData.IMAGE_AVATAR_SHIELD) {// //身份证正面头像有遮挡
			return getString(R.string.image_avatar_shield);
		} else {
			return completeType + "";
		}

	}

	// ***********************************UI***************************************/
	ViewPager vp;
	RadioGroup group;
	ViewPagerAdapter vpAdapter;
	int currentItem;

	@SuppressWarnings("deprecation")
	public void initPagerView(String path1, String path2) {

		vp = (ViewPager) findViewById(R.id.viewpager);
		group = (RadioGroup) findViewById(R.id.RadioGroup);
		group.setOnCheckedChangeListener(listener);
		views = new ArrayList<View>();

		LinearLayout.LayoutParams mParams = new LinearLayout.LayoutParams(
				LinearLayout.LayoutParams.WRAP_CONTENT,
				LinearLayout.LayoutParams.WRAP_CONTENT);
		mParams.setMargins(20, 20, 20, 20);
		if (!TextUtils.isEmpty(path2)) {
			pathList.add(path2);
			MyZoomImageView iv2 = new MyZoomImageView(this);
			iv2.setLayoutParams(mParams);

			Bitmap bmp = loadBitmap(path2);
			if (bmp != null) {
				iv2.setImageBitmap(bmp);
			}

			iv2.setScaleType(ScaleType.FIT_CENTER);
			iv2.initUI();
			views.add(iv2);
		} else {
			group.setVisibility(View.GONE);
		}
		if (!TextUtils.isEmpty(path1)) {
			pathList.add(path1);
			MyZoomImageView iv = new MyZoomImageView(this);
			iv.setLayoutParams(mParams);

			Bitmap bmp = loadBitmap(path1);
			if (bmp != null) {
				iv.setImageBitmap(bmp);
			}

			iv.setScaleType(ScaleType.FIT_CENTER);
			iv.initUI();
			views.add(iv);
		} else {
			group.setVisibility(View.GONE);
		}
		vpAdapter = new ViewPagerAdapter(views);
		vp.setAdapter(vpAdapter);
		vp.setOnPageChangeListener(new OnPageChangeListener() {

			@Override
			public void onPageSelected(final int position) {
				final RadioButton radioButton = (RadioButton) group
						.getChildAt(position);
				radioButton.setChecked(true);
				currentItem = position;
			}

			@Override
			public void onPageScrolled(final int arg0, final float arg1, final int arg2) {

			}

			@Override
			public void onPageScrollStateChanged(final int arg0) {

			}
		});
		findViewById(R.id.rotation_title_id).setOnClickListener(
				new OnClickListener() {

					@Override
					public void onClick(View arg0) {
						// TODO Auto-generated method stub
						rotation[currentItem] = rotation[currentItem] + 90;
						if (rotation[currentItem] < 360) {
							setRoateImageview(rotation[currentItem]);
						} else {
							rotation[currentItem] = 0;
							setRoateImageview(rotation[currentItem]);
						}
					}
				});
	}

	int[] rotation = new int[2];
	List<View> views;
	List<String> pathList = new ArrayList<String>();

	public void setRoateImageview(int progress) {

		MyZoomImageView imageView = (MyZoomImageView) views.get(currentItem);
		// imageView.setDrawingCacheEnabled(true);
		Bitmap bitmap = loadBitmap(pathList.get(currentItem));
		// 设置旋转角度
		Matrix matrix = new Matrix();
		matrix.setRotate(progress);
		// 重新绘制Bitmap
		bitmap = Bitmap.createBitmap(bitmap, 0, 0, bitmap.getWidth(),
				bitmap.getHeight(), matrix, true);
		imageView.setImageBitmap(bitmap);
		// imageView.setDrawingCacheEnabled(false);
		imageView.setScaleType(ScaleType.FIT_CENTER);
		imageView.initUI();
	}

	OnCheckedChangeListener listener = new OnCheckedChangeListener() {

		@Override
		public void onCheckedChanged(RadioGroup group, int checkId) {
			switch (checkId) {
			case R.id.radio1:
				vp.setCurrentItem(0);
				currentItem = 0;
				break;
			case R.id.radio2:
				vp.setCurrentItem(1);
				currentItem = 1;
				break;

			default:
				break;
			}
		}
	};

	public void setBackgroundAlpha(float bgAlpha) {
		WindowManager.LayoutParams lp = getWindow().getAttributes();
		if (bgAlpha == 1) {
			getWindow().clearFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND);// 不移除该Flag的话,在有视频的页面上的视频会出现黑屏的bug
		} else {
			getWindow().addFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND);// 此行代码主要是解决在华为手机上半透明效果无效的bug
		}
		lp.alpha = bgAlpha;

		RecogResultActivity.this.getWindow().setAttributes(lp);
	}

	String shotPathString;
	TextView tv_label_id;
	OnClickListener onClickListenerTrim = new OnClickListener() {

		@Override
		public void onClick(View arg0) {
			// TODO Auto-generated method stub
			RelativeLayout layout = (RelativeLayout) LayoutInflater.from(
					RecogResultActivity.this).inflate(
					R.layout.cui_view_loadingdialog, null);
			final PopupWindow popupWindow = new PopupWindow(layout,
					ViewGroup.LayoutParams.WRAP_CONTENT,
					ViewGroup.LayoutParams.WRAP_CONTENT, true);

			ImageView loading_image = (ImageView) layout
					.findViewById(R.id.loading_image);
			Bitmap bmp = loadBitmap(shotPathString);
			if (bmp != null) {
				loading_image.setImageBitmap(bmp);

			}
			setBackgroundAlpha(0.8f);
			popupWindow.showAsDropDown(tv_label_id);

			popupWindow.setOutsideTouchable(true);
			popupWindow.setTouchable(true);
			popupWindow.setFocusable(true);
			layout.setOnClickListener(new OnClickListener() {

				@Override
				public void onClick(View arg0) {
					// TODO Auto-generated method stub
					Log.e("setBackgroundAlpha", "1f");
					setBackgroundAlpha(1f);

					popupWindow.dismiss();
				}
			});

		}
	};
}
